/*
 * This plugin is follow all the rules of jQuery
 * copyright (c) 2018 cattlemute
 */

(function($){

	$.fn.scrollblink = function(options){
		var option = {
			contents: 'contents',
			show: 'show',
		};
		var static = {
			contents: 'scrollblink-contents',
			show: 'scrollblink-show',
			showChildren: 'scrollblink-show-children',
			active: 'scrollblink-active',
			prep: 'scrollblink-prep',
		};
		var config = $.extend(option, options);
		var inc = $(this), contents = null, shows = null, nowscroll = 0, lastscroll = 0;

		var scrollblink = (function(){
			return{
				init: function(){
					inc.children('.' + config.contents).addClass(static.contents);
					inc.children('.' + config.show).addClass(static.show + ' ' + static.prep)
						.children().addClass(static.showChildren);
					scrollblink.setshow();
					scrollblink.clip();
				},
				clip: function(){
					$(window).bind('scroll', function(){
						scrollblink.activate();
					});
					$(window).bind('load', function(){
						$('.' + static.show).removeClass(static.prep);
						scrollblink.activate();
					});
				},
				setshow: function(){
					$('.' + static.show).children('.' + static.showChildren).each(function(n){
						$(this).css({
							'z-index': $('.' + static.show).children('.' + static.showChildren).length - n
						});
					});
				},
				activate: function($direct){

					nowscroll = $(window).scrollTop();

					contents = $('.' + static.contents);
					show = $('.' + static.show).children('.' + static.showChildren);

					contents.each(function(n){

						if( $(this).offset().top - Math.floor( window.innerHeight / 3 ) <= $(window).scrollTop() && $(this).offset().top + $(this).outerHeight(true) + Math.floor( window.innerHeight / 2 ) >= $(window).scrollTop() + window.innerHeight ){

							$(this).addClass(static.active);
							show.eq(n).removeClass(static.preactive);
							show.eq(n).addClass(static.active);

						} else if( $(this).hasClass(static.active) ) {

							$(this).removeClass(static.active);
							show.eq(n).removeClass(static.active);

						}

					});

					lastscroll = $(window).scrollTop();

				}
			};
		})();

		scrollblink.init();

		return(this);
	};

})(jQuery);
